#include <Leg.h>
#include <Arduino.h>
#include <Servo.h>
#define L1 9
#define L2 16

void Leg::attach(int pov, int col, int nog, bool isLeft){
    s0.attach(pov);
    s2.attach(col);
    s3.attach(nog);
    _isLeft = isLeft;
}

void Leg::attach(int pov, int col, int nog, bool isLeft, bool Forward){
    s0.attach(pov);
    s2.attach(col);
    s3.attach(nog);
    _isLeft = isLeft;
    _Forward = Forward;
}

void Leg::move(float xm, float ym, float zm){
    float h, s, m, s1, u, b, v, p, a;
    if (z >= zm) {
    h = abs(z - zm);
    s = abs(ym - y);
    m = h * h + s * s;
    s1 = sqrt(m);
    u = (L1 * L1 + L2 * L2 - s1 * s1) / 2 / L1 / L2;
    b = acos(u) * 180 / PI;
    u = (s1 * s1 + L1 * L1 - L2 * L2) / 2 / s1 / L1;
    v = acos(u) * 180 / PI;
    u = h / s1;
    p = acos(u) * 180 / PI;
    a = 180 - v - p;
    if (0 < a < 180 && 0 < b < 180) {
      if (_isLeft == true) {
        s2.write(180 - a);
        s3.write(180 - b);
      }
      else {
        s2.write(a);
        s3.write(b);
      }
    }
  }
  else {
    h = abs(z - zm);
    s = abs(y - ym);
    m = h * h + s * s;
    s1 = sqrt(m);
    u = (L1 * L1 + L2 * L2 - s1 * s1) / 2 / L1 / L2;
    b = acos(u) * 180 / PI;
    u = (s1 * s1 + L1 * L1 - L2 * L2) / 2 / s1 / L1;
    v = acos(u) * 180 / PI;
    u = h / s1;
    p = asin(u) * 180 / PI;
    a = 90 - v - p;
    if (0 < a < 180 && 0 < b < 180) {
      if (_isLeft == true) {
        s2.write(180 - a);
        s3.write(180 - b);
      }
      else {
        s2.write(a);
        s3.write(b);
      }
    }
  }
  if(_isLeft == true){
     if(xm >= x){
  	    h = abs(x - xm);
     	s = abs(y - ym);
     	m = h * h + s * s;
        s1 = sqrt(m);
        m = s / s1;
        a = asin(m) * 180 / PI;
        s0.write(180 - a);
     }
     else{
     	h = abs(x - xm);
     	s = abs(y - ym);
      	m = h * h + s * s;
        s1 = sqrt(m);
        m = s / s1;
        a = asin(m) * 180 / PI;
        s0.write(a);
     }
   }
   else{
   	if(xm >= x){
  	    h = abs(x - xm);
     	s = abs(y - ym);
     	m = h * h + s * s;
        s1 = sqrt(m);
        m = s / s1;
        a = asin(m) * 180 / PI;
        s0.write(a);
     }
     else{
     	h = abs(x - xm);
     	s = abs(y - ym);
      	m = h * h + s * s;
        s1 = sqrt(m);
        m = s / s1;
        a = asin(m) * 180 / PI;
        s0.write(180 - a);
     }
   }
}

void Leg::set(float x2, float y2, float z2){
	x = x2;
	y = y2;
	z = z2 + 4;
}

void Leg::move(float xm, float ym, float zm, bool calc){
    float h, s, m, s1, u, b, v, p, a;
    if(calc == true){
      if(_Forward == true){
        xm = xm*cos(33)+ym*sin(33);
        ym = xm*sin(33)-ym*cos(33);
      }
      else{
        xm = xm*cos(29)+ym*sin(29);
        ym = xm*sin(29)-ym*cos(29);
      }
    }

    if (z >= zm) {
    h = abs(z - zm);
    s = abs(y - ym);
    m = h * h + s * s;
    s1 = sqrt(m);
    u = (L1 * L1 + L2 * L2 - s1 * s1) / 2 / L1 / L2;
    b = acos(u) * 180 / PI;
    u = (s1 * s1 + L1 * L1 - L2 * L2) / 2 / s1 / L1;
    v = acos(u) * 180 / PI;
    u = h / s1;
    p = acos(u) * 180 / PI;
    a = 180 - v - p;
    if (0 < a < 180 && 0 < b < 180) {
      if (_isLeft == true) {
        s2.write(180 - a);
        s3.write(180 - b);
      }
      else {
        s2.write(a);
        s3.write(b);
      }
    }
  }
  else {
    h = abs(z - zm);
    s = abs(y - ym);
    m = h * h + s * s;
    s1 = sqrt(m);
    u = (L1 * L1 + L2 * L2 - s1 * s1) / 2 / L1 / L2;
    b = acos(u) * 180 / PI;
    u = (s1 * s1 + L1 * L1 - L2 * L2) / 2 / s1 / L1;
    v = acos(u) * 180 / PI;
    u = h / s1;
    p = asin(u) * 180 / PI;
    a = 90 - v - p;
    if (0 < a < 180 && 0 < b < 180) {
      if (_isLeft == true) {
        s2.write(180 - a);
        s3.write(180 - b);
      }
      else {
        s2.write(a);
        s3.write(b);
      }
    }
  }
  if(_isLeft == true){
     if(xm >= x){
  	    h = abs(x - xm);
     	s = abs(y - ym);
     	m = h * h + s * s;
        s1 = sqrt(m);
        m = s / s1;
        a = asin(m) * 180 / PI;
        s0.write(180 - a);
     }
     else{
     	h = abs(x - xm);
     	s = abs(y - ym);
      	m = h * h + s * s;
        s1 = sqrt(m);
        m = s / s1;
        a = asin(m) * 180 / PI;
        s0.write(a);
     }
   }
   else{
   	if(xm >= x){
  	    h = abs(x - xm);
     	s = abs(y - ym);
     	m = h * h + s * s;
        s1 = sqrt(m);
        m = s / s1;
        a = asin(m) * 180 / PI;
        s0.write(a);
     }
     else{
     	h = abs(x - xm);
     	s = abs(y - ym);
      	m = h * h + s * s;
        s1 = sqrt(m);
        m = s / s1;
        a = asin(m) * 180 / PI;
        s0.write(180 - a);
     }
   }
}

