#include <Leg.h>
#include <ros.h>
#include <geometry_msgs/Twist.h>
#include <std_msgs/Bool.h>
#include <geometry_msgs/Vector3.h>

Leg l1, l2, l3, l4, l5, l6;
float klirens = 10, x = 0, y = 12;
ros::NodeHandle  nh;
void move_test( const geometry_msgs::Twist& message)
{
  geometry_msgs::Vector3 linear = message.linear;
  float forward_vel = float(linear.x);
  geometry_msgs::Vector3 angular = message.angular;
  float ang_vel = float(angular.y);

  if (forward_vel == 1) move_forward();
  if (forward_vel == -1) move_backward();

  if (ang_vel == 1) turn_left();
  if (ang_vel == -1) turn_right();

}


void tarantul( const std_msgs::Bool& msg) {
  if(msg.data == 1){
  for (float i = 0; i <= 8; i += 0.5) {
    l3.move(0, 12, i);
    l4.move(0, 12, i);
    delay(50);
  }
  delay(1000);
  for (float i = 0; i <= 14; i += 0.5) {
    l6.move(0, 15, i);
    l1.move(0, 15, i);
    delay(50);
  }
  delay(1000);
  for (float i = 14; i >= 0; i -= 0.5) {
    l6.move(0, 15, i);
    l1.move(0, 15, i);
    delay(50);
  }
  delay(1000);
  for (float i = 8; i >= 0; i -= 0.5) {
    l3.move(0, 12, i);
    l4.move(0, 12, i);
    delay(50);
  }
  delay(1000);
  }
}


void move_forward() {
  l1.move(1.87, 14.63, 10);
  l5.move(5, 10, 10);
  l3.move(0, 10, 10);
  delay(50);
  l1.move(1.87, 14.63, 0);
  l5.move(5, 10, 0);
  l3.move(0, 10, 0);
  delay(100);
  l2.move(0, 10, 10);
  l4.move(0, 10, 10);
  l6.move(0, 10, 10);
  delay(50);

  l1.move(0, 10, 0);
  l3.move(-2.72, 14.19, 0);
  l5.move(0, 10, 0);
  delay(100);
  l2.move(0, 10, 0);
  l4.move(0, 10, 0);
  l6.move(0, 10, 0);
  delay(100);

  l6.move(1.87, 14.63, 7);
  l2.move(5, 10, 10);
  l4.move(0, 10, 10);
  delay(50);
  l6.move(1.87, 14.63, 0);
  l2.move(5, 10, 0);
  l4.move(0, 10, 0);
  delay(100);
  l5.move(0, 10, 10);
  l3.move(0, 10, 10);
  l1.move(0, 10, 10);
  delay(50);

  l6.move(0, 10, 0);
  l4.move(-2.72, 14.19, 0);
  l2.move(0, 10, 0);
  delay(100);
  l5.move(0, 10, 0);
  l3.move(0, 10, 0);
  l1.move(0, 10, 0);
  delay(100);
}

void turn_left() {
  l1.move(6, 10.39, 5);
  l5.move(-6, 10.39, 5);
  l3.move(6, 10.39, 5);
  delay(100);
  l1.move(6, 10.39, 0);
  l5.move(-6, 10.39, 0);
  l3.move(6, 10.39, 0);
  delay(100);
  l6.move(-6, 10.39, 5);
  l2.move(6, 10.39, 5);
  l4.move(-6, 10.39, 5);
  delay(100);
  l6.move(-6, 10.39, 0);
  l2.move(6, 10.39, 0);
  l4.move(-6, 10.39, 0);
  delay(100);


  l1.move(0, 12, 0);
  l2.move(0, 12, 0);
  l3.move(0, 12, 0);
  l4.move(0, 12, 0);
  l5.move(0, 12, 0);
  l6.move(0, 12, 0);
  delay(100);
}

void turn_right() {
  l1.move(-6, 10.39, 5);
  l5.move(6, 10.39, 5);
  l3.move(-6, 10.39, 5);
  delay(100);
  l1.move(-6, 10.39, 0);
  l5.move(6, 10.39, 0);
  l3.move(-6, 10.39, 0);
  delay(100);
  l6.move(6, 10.39, 5);
  l2.move(-6, 10.39, 5);
  l4.move(6, 10.39, 5);
  delay(100);
  l6.move(6, 10.39, 0);
  l2.move(-6, 10.39, 0);
  l4.move(6, 10.39, 0);
  delay(100);


  l1.move(0, 12, 0);
  l2.move(0, 12, 0);
  l3.move(0, 12, 0);
  l4.move(0, 12, 0);
  l5.move(0, 12, 0);
  l6.move(0, 12, 0);
  delay(100);
}

void move_backward() {
  l3.move(-1.87, 14.63, 7);
  l5.move(-5, 10, 7);
  l1.move(0, 10, 7);
  delay(50);
  l3.move(-1.87, 14.63, 0);
  l5.move(-5, 10, 0);
  l1.move(0, 10, 0);
  delay(100);
  l2.move(0, 10, 7);
  l4.move(0, 10, 7);
  l6.move(0, 10, 7);
  delay(50);

  l3.move(0, 10, 0);
  l1.move(2.72, 14.19, 0);
  l5.move(0, 10, 0);
  delay(100);
  l2.move(0, 10, 0);
  l4.move(0, 10, 0);
  l6.move(0, 10, 0);
  delay(100);

  l4.move(-1.87, 14.63, 7);
  l2.move(-5, 10, 7);
  l6.move(0, 10, 7);
  delay(50);
  l4.move(-1.87, 14.63, 0);
  l2.move(-5, 10, 0);
  l6.move(0, 10, 0);
  delay(100);
  l5.move(0, 10, 7);
  l1.move(0, 10, 7);
  l3.move(0, 10, 7);
  delay(50);

  l4.move(0, 10, 0);
  l6.move(2.72, 14.19, 0);
  l2.move(0, 10, 0);
  delay(100);
  l5.move(0, 10, 0);
  l3.move(0, 10, 0);
  l1.move(0, 10, 0);
  delay(100);
}

void klirensup(const std_msgs::Bool& msg){
  if((msg.data == true) && (klirens >= 4)){
      klirens -= 0.5;
      l1.set(0, 0, klirens);
      l2.set(0, 0, klirens);
      l3.set(0, 0, klirens);
      l4.set(0, 0, klirens);
      l5.set(0, 0, klirens);
      l6.set(0, 0, klirens);
      l1.move(0, 12, 0);
      l2.move(0, 12, 0);
      l3.move(0, 12, 0);
      l4.move(0, 12, 0);
      l5.move(0, 12, 0);
      l6.move(0, 12, 0);
  }
}

void klirensdown(const std_msgs::Bool& msg){
  if((msg.data == true) && (klirens <= 17)){
      klirens += 0.5;
      l1.set(0, 0, klirens);
      l2.set(0, 0, klirens);
      l3.set(0, 0, klirens);
      l4.set(0, 0, klirens);
      l5.set(0, 0, klirens);
      l6.set(0, 0, klirens);
      l1.move(0, 12, 0);
      l2.move(0, 12, 0);
      l3.move(0, 12, 0);
      l4.move(0, 12, 0);
      l5.move(0, 12, 0);
      l6.move(0, 12, 0);
  }
}


ros::Subscriber<geometry_msgs::Twist> sub("/cmd_vel", &move_test);
ros::Subscriber<std_msgs::Bool> sub2("tarantul", &tarantul);
ros::Subscriber<std_msgs::Bool> sub3("klirensup", &klirensup);
ros::Subscriber<std_msgs::Bool> sub4("klirensdown", &klirensdown);


void setup() {
  nh.getHardware()->setBaud(57600);
  nh.initNode();
  nh.subscribe(sub);
  nh.subscribe(sub2);
  nh.subscribe(sub3);
  nh.subscribe(sub4);
  l1.attach(17, 20, 21, false, true);
  l2.attach(3, 2, 19, false);
  l3.attach(9, 8, 7, false, false);
  l4.attach(12, 11, 10, true, false);
  l5.attach(6, 5, 4, true);
  l6.attach(14, 15, 16, true, true);
  l1.set(0, 0, 0);
  l2.set(0, 0, 0);
  l3.set(0, 0, 0);
  l4.set(0, 0, 0);
  l5.set(0, 0, 0);
  l6.set(0, 0, 0);
  l1.move(0, 12, 0);
  l2.move(0, 12, 0);
  l3.move(0, 12, 0);
  l4.move(0, 12, 0);
  l5.move(0, 12, 0);
  l6.move(0, 12, 0);
  delay(1000);
  for (float i = 0; i <= 10; i += 0.5) {
    l1.set(0, 0, i);
    l2.set(0, 0, i);
    l3.set(0, 0, i);
    l4.set(0, 0, i);
    l5.set(0, 0, i);
    l6.set(0, 0, i);
    l1.move(0, 12, 0);
    l2.move(0, 12, 0);
    l3.move(0, 12, 0);
    l4.move(0, 12, 0);
    l5.move(0, 12, 0);
    l6.move(0, 12, 0);
    delay(50);
  }
  delay(5000);
}

void loop() {
  nh.spinOnce();
  delay(1);
}
