#include "ros/ros.h"
#include <std_msgs/Bool.h>
#include <geometry_msgs/Twist.h>
#include <geometry_msgs/Vector3.h>
#include <sensor_msgs/Joy.h>
#include <sstream>
geometry_msgs::Twist twist;
std_msgs::Bool tar, klu, kld;

void knopki(const sensor_msgs::Joy::ConstPtr& msg)
{
  tar.data = msg->buttons[14];
  ROS_INFO("Sostojanie krestika = %i", tar.data);
  klu.data = msg->buttons[9];
  kld.data = msg->buttons[8];
}

void move(const sensor_msgs::Joy::ConstPtr& msg)
{
      twist.linear.x = msg->axes[1]; 
      twist.angular.y = msg->axes[2];
      twist.linear.y=msg->axes[0];
}

int main(int argc, char **argv)
{

  ros::init(argc, argv, "joy_test");
  ros::NodeHandle n;
  ros::Publisher pub = n.advertise<geometry_msgs::Twist>("/cmd_vel", 1000);
  ros::Publisher pub2 = n.advertise<std_msgs::Bool>("tarantul", 1000);
  ros::Publisher pub3 = n.advertise<std_msgs::Bool>("klirensup", 1000);
  ros::Publisher pub4 = n.advertise<std_msgs::Bool>("klirensdown", 1000);
  ros::Subscriber sub = n.subscribe<sensor_msgs::Joy>("joy", 1000, knopki);
  ros::Subscriber sub2 = n.subscribe<sensor_msgs::Joy>("joy", 1000, move);
  ros::Rate loop_rate(7);
  ros::Rate loop_rate2(50);

  while (ros::ok())
  {
    pub.publish(twist);
    pub2.publish(tar);
    pub3.publish(klu);
    pub4.publish(kld);
    ros::spinOnce();
    loop_rate.sleep();
    }

  while (ros::ok())
  {
    pub3.publish(klu);
    pub4.publish(kld);
    ros::spinOnce();
    loop_rate2.sleep();
    }

  return 0;
}
